#!/usr/bin/env python


import urllib,urllib2,sys,re,xbmcplugin,xbmcgui,xbmcaddon,xbmc,os,urlparse,re


base_url = sys.argv[0]
addon_handle = int(sys.argv[1])
args = urlparse.parse_qs(sys.argv[2][1:])

#todo look this up
xbmcplugin.setContent(addon_handle, 'audio')


MODE_INDEX = "1"
MODE_LISTEN_LIVE = "2"
MODE_LISTEN_AGAIN_INDEX = "3"
MODE_LISTEN_AGAIN_DJ = "4"

main_url = "http://www.radiox.co.uk/london/radio/player/"
# I should probably read these from ther link above. 
live_url1 = 'http://media-aws.musicradio.com/RadioXUK?type=.flv'
live_url2 = "http://media-ice.musicradio.com/RadioXLondonMP3"

#this is the base offset for the audio links and the images - this will be they bit they break.
audio_base = "http://fs.geronimo.thisisglobal.com/audio/"
icon_base = "http://fs.geronimo.thisisglobal.com/image/"

#work out what to do 
mode = args.get('mode', None)
if mode != None:
    mode = mode[0]

def build_url(query):
    """helper function to callback self with different links"""
    return base_url + '?' + urllib.urlencode(query)

def get_dj_list():
    """Find a list off all dj shows """
    #get all the dj's names 
    fp = urllib.urlopen('http://listenagainproxy.geronimo.thisisglobal.com/api/Stations/59/Channels?callback=getChannelsByStationId')

    #now mash this into a dictionary
    null = 0
    false = 0
    true = 1
    content = fp.read()
    #make this python compatible
    content = content.lstrip("getEpisodesByChannelId(StationId(").rstrip(");")

    dj_info = eval(content)
    
    for dj in dj_info:
        url = build_url({'mode': MODE_LISTEN_AGAIN_DJ, "DJ_ID":dj["ChannelId"]})
        li = xbmcgui.ListItem(dj["Name"], iconImage=icon_base+dj["ImageFile"])
        xbmcplugin.addDirectoryItem(handle=addon_handle, url=url, listitem=li, isFolder=True)
    fp.close()

def get_episodes():
    """Now that a DJ has been chosen, go get the shows that we can catch up on. """
    dj_id = args.get('DJ_ID', None)[0]
    
    fp = urllib.urlopen('http://listenagainproxy.geronimo.thisisglobal.com/api/Channels/'+ dj_id +'/Episodes?callback=getEpisodesByChannelId')
    
    content = fp.read()
    #make this python compatible
    null = 0
    false = 0
    true = 1
    content = content.lstrip("getEpisodesByChannelId(").rstrip(");")
    show_info = eval(content)
    
    for show in show_info:
        try:
            image = icon_base + show["ImageFile"]
        except KeyError:
            image = "defaultAudio.png"
        show_url = audio_base + show["MediaFiles"][0]["Filename"]
        li = xbmcgui.ListItem(show["Name"], iconImage=image)
        xbmcplugin.addDirectoryItem(handle=addon_handle, url=show_url, listitem=li)
    fp.close()

if mode == None or mode == MODE_INDEX:
    #top level menu shows live streams or listen again folder
    getNext = False
    live_pic = "defaultAudio.png"
    show = ""
    try:
        fp = urllib.urlopen(main_url)
        for line in fp.readlines():
            if "schedules:" in line:
                a =  line
                schedule = eval(a.lstrip().lstrip("schedules: ").rstrip(",\n"))
                getNext = True
            elif getNext == True:
                getNext = False
                nowOn = line.split("'")[1]
        
        for prog in schedule:
            if prog["title"] == nowOn:
                live_pic = prog["image"] + "&w=150"
                show = nowOn
    except:
        live_pic = "defaultAudio.png"
        show = ""
        
    fp.close()

    li = xbmcgui.ListItem('Listen Live '+ show +' MP4', iconImage=live_pic)
    xbmcplugin.addDirectoryItem(handle=addon_handle, url=live_url1, listitem=li)

    li = xbmcgui.ListItem('Listen Live '+show+' MP3', iconImage=live_pic)
    xbmcplugin.addDirectoryItem(handle=addon_handle, url=live_url2, listitem=li)

    #submenu for listen again
    url = build_url({'mode': MODE_LISTEN_AGAIN_INDEX})
    li = xbmcgui.ListItem('Listen again', iconImage='DefaultFolder.png')
    xbmcplugin.addDirectoryItem(handle=addon_handle, url=url, listitem=li, isFolder=True)

elif mode == MODE_LISTEN_AGAIN_INDEX:
    get_dj_list()

elif mode == MODE_LISTEN_AGAIN_DJ:
    get_episodes()

else:
    li = xbmcgui.ListItem("debug " + str(mode) + str(type(mode)), iconImage=chris_png)
    xbmcplugin.addDirectoryItem(handle=addon_handle, url=moyles_friday_url, listitem=li)
    

#script finished
xbmcplugin.endOfDirectory(addon_handle)
